;; *** constants ***

(define_insn "loadaddr"
   [(set (match_operand:DI 0 "register_operand" "=r")
         (label_ref (match_operand 1 "" "")))]
   ""
   "loadaddri\\t%1, %0")

(define_insn "loadcons"
   [(set (match_operand 0 "register_operand" "=r")
         (ior (and (match_operand 1 "register_operand" "0")
                   (not (ashift (const_int 0xFFFF)
                                (ashift (match_operand 3 "const_int_operand" "")
                                        (const_int 4)))))
              (and (match_operand 2 "immediate_operand" "")
                   (ashift (const_int 0xFFFF)
                           (ashift (match_dup 3)
                                   (const_int 4))))))]
   ""
   "loadcons.%3\\t%2 @ %3, %0")

;;; *** move ***

(define_expand "movdi"
   [(set (match_operand:DI 0 "general_operand" "=r,r,m,r")
         (match_operand:DI 1 "general_operand"  "r,m,r,i"))]
   ""
   "{
        if (fcpu_move_emit (operands [0], operands [1]) != NULL_RTX)
          DONE;
    }")

(define_expand "movsi"
   [(set (match_operand:SI 0 "general_operand" "=r,r,m,r")
         (match_operand:SI 1 "general_operand"  "r,m,r,i"))]
   ""
   "{
        if (fcpu_move_emit (operands [0], operands [1]) != NULL_RTX)
          DONE;
    }")

(define_insn ""
   [(set (match_operand:DI 0 "general_operand" "=r,r,m,r,m,r")
         (match_operand:DI 1 "general_operand"  "r,m,r,N,N,I"))]
   ""
   "@
    move\\tr0, %1, %0
    load\\t%1, %0
    store\\t%0, %1
    move\\tr0, r0, %0
    store\\t%0, r0
    * loadconsx.0\\t%1, %0")

(define_insn ""
   [(set (match_operand:SI 0 "general_operand" "=r,r,m,r,m,r")
         (match_operand:SI 1 "general_operand"  "r,m,r,N,N,I"))]
   ""
   "@
    move32\\tr0, %1, %0
    load32\\t%1, %0
    store32\\t%0, %1
    move32\\tr0, r0, %0
    store32\\t%0, r0
    loadconsx.0\\t%1, %0")

(define_insn "movhi"
   [(set (match_operand:HI 0 "general_operand" "=r,r,m,r,m,r,r")
         (match_operand:HI 1 "general_operand"  "r,m,r,N,N,J,I"))]
   ""
   "@
    move16\\tr0, %1, %0
    load16\\t%1, %0
    store16\\t%0, %1
    move16\\tr0, r0, %0
    store16\\t%0, r0
    loadconsx.0\\t%1, %0
    loadconsx.0\\t%1, %0")

(define_insn "movqi"
   [(set (match_operand:QI 0 "general_operand" "=r,r,m,r,m,r,r")
         (match_operand:QI 1 "general_operand"  "r,m,r,N,N,L,K"))]
   ""
   "@
    move8\\tr0, %1, %0
    load8\\t%1, %0
    store8\\t%0, %1
    move8\\tr0, r0, %0
    store8\\t%0, r0
    loadconsx.0\\t%1, %0
    loadconsx.0\\t%1, %0")

(define_expand "movdf"
   [(set (match_operand:DF 0 "general_operand" "=r,r,m,r")
         (match_operand:DF 1 "general_operand"  "r,m,r,F"))]
   ""
   "{
       if (fcpu_move_emit (operands [0], operands [1]) != NULL_RTX)
         DONE;
    }")

(define_expand "movsf"
   [(set (match_operand:SF 0 "general_operand" "=r,r,m,r")
         (match_operand:SF 1 "general_operand"  "r,m,r,F"))]
   ""
   "{
       if (fcpu_move_emit (operands [0], operands [1]) != NULL_RTX)
         DONE;
    }")

(define_insn ""
   [(set (match_operand:DF 0 "general_operand" "=r,r,m")
         (match_operand:DF 1 "general_operand"  "r,m,r"))]
   ""
   "@
    move\\tr0, %1, %0
    load\\t%1, %0
    store\\t%0, %1")

(define_insn ""
   [(set (match_operand:SF 0 "general_operand" "=r,r,m")
         (match_operand:SF 1 "general_operand"  "r,m,r"))]
   ""
   "@
    move32\\tr0, %1, %0
    load32\\t%1, %0
    store32\\t%0, %1")

;;; *** floating-point conversion ***

(define_insn "fix_truncdfdi2"
   [(set (match_operand:DI 0 "register_operand" "=r")
         (fix:DI (match_operand:DF 1 "register_operand" "r")))]
   ""
   "f2int\\t%1, %0")

(define_insn "fix_truncsfdi2"
   [(set (match_operand:DI 0 "register_operand" "=r")
         (fix:DI (match_operand:SF 1 "register_operand" "r")))]
   ""
   "f2int32\\t%1, %0")

(define_insn "floatdidf2"
   [(set (match_operand:DF 0 "register_operand" "=r")
         (float:DF (match_operand:DI 1 "register_operand" "r")))]
   ""
   "int2f\\t%1, %0")

(define_insn "floatdisf2"
   [(set (match_operand:SF 0 "register_operand" "=r")
         (float:SF (match_operand:DI 1 "register_operand" "r")))]
   ""
   "int2f32\\t%1, %0")

(define_expand "float_expand"
   [(set (match_operand 0 "register_operand" "=r")
         (unspec [(match_operand 1 "register_operand" "r")] 0))]
   ""
   "")

(define_insn ""
   [(set (match_operand:DI 0 "register_operand" "=r")
         (unspec [(match_operand:DF 1 "register_operand" "r")] 0))]
   ""
   "* return fcpu_float_expand_output (operands [0], operands [1]);")

(define_insn ""
   [(set (match_operand:SI 0 "register_operand" "=r")
         (unspec [(match_operand:SF 1 "register_operand" "r")] 0))] 
   ""
   "* return fcpu_float_expand_output (operands [0], operands [1]);")

(define_insn ""
   [(set (match_operand:DI 0 "register_operand" "=r")
         (unspec [(match_operand:SF 1 "register_operand" "r")] 0))]
   ""
   "* return fcpu_float_expand_output (operands [0], operands [1]);")

;;; *** arithmetic shift left ***

(define_insn "ashldi3"
   [(set (match_operand:DI 0 "register_operand" "=r,r")
         (ashift:DI (match_operand:DI 1 "register_operand" "r,r")
                    (match_operand:DI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftl\\t%2, %1, %0
    shiftli\\t%2, %1, %0")

(define_insn "ashlsi3"
   [(set (match_operand:SI 0 "register_operand" "=r,r")
         (ashift:SI (match_operand:SI 1 "register_operand" "r,r")
                    (match_operand:SI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftl32\\t%2, %1, %0
    shiftli32\\t%2, %1, %0")

(define_insn "ashlhi3"
   [(set (match_operand:HI 0 "register_operand" "=r,r")
         (ashift:HI (match_operand:HI 1 "register_operand" "r,r")
                    (match_operand:HI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftl16\\t%2, %1, %0
    shiftli16\\t%2, %1, %0")

(define_insn "ashlqi3"
   [(set (match_operand:QI 0 "register_operand" "=r,r")
         (ashift:QI (match_operand:QI 1 "register_operand" "r,r")
                    (match_operand:QI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftl8\\t%2, %1, %0
    shiftli8\\t%2, %1, %0")

;;; *** arithmetic shift right ***

(define_insn "ashrdi3"
   [(set (match_operand:DI 0 "register_operand" "=r,r")
         (ashiftrt:DI (match_operand:DI 1 "register_operand" "r,r")
                      (match_operand:DI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftra\\t%2, %1, %0
    shiftrai\\t%2, %1, %0")

(define_insn "ashrsi3"
   [(set (match_operand:SI 0 "register_operand" "=r,r")
         (ashiftrt:SI (match_operand:SI 1 "register_operand" "r,r")
                      (match_operand:SI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftra32\\t%2, %1, %0
    shiftrai32\\t%2, %1, %0")

(define_insn "ashrhi3"
   [(set (match_operand:HI 0 "register_operand" "=r,r")
         (ashiftrt:HI (match_operand:HI 1 "register_operand" "r,r")
                      (match_operand:HI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftra16\\t%2, %1, %0
    shiftrai16\\t%2, %1, %0")

(define_insn "ashrqi3"
   [(set (match_operand:QI 0 "register_operand" "=r,r")
         (ashiftrt:QI (match_operand:QI 1 "register_operand" "r,r")
                      (match_operand:QI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftra8\\t%2, %1, %0
    shiftrai8\\t%2, %1, %0")

;;; *** logical shift right ***

(define_insn "lshrdi3"
   [(set (match_operand:DI 0 "register_operand" "=r,r")
         (lshiftrt:DI (match_operand:DI 1 "register_operand" "r,r")
                      (match_operand:DI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftr\\t%2, %1, %0
    shiftri\\t%2, %1, %0")

(define_insn "lshrsi3"
   [(set (match_operand:SI 0 "register_operand" "=r,r")
         (lshiftrt:SI (match_operand:SI 1 "register_operand" "r,r")
                      (match_operand:SI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftr32\\t%2, %1, %0
    shiftri32\\t%2, %1, %0")

(define_insn "lshrhi3"
   [(set (match_operand:HI 0 "register_operand" "=r,r")
         (lshiftrt:HI (match_operand:HI 1 "register_operand" "r,r")
                      (match_operand:HI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftr16\\t%2, %1, %0
    shiftri16\\t%2, %1, %0")

(define_insn "lshrqi3"
   [(set (match_operand:QI 0 "register_operand" "=r,r")
         (lshiftrt:QI (match_operand:QI 1 "register_operand" "r,r")
                      (match_operand:QI 2 "general_operand"  "r,L")))]
   ""
   "@
    shiftr8\\t%2, %1, %0
    shiftri8\\t%2, %1, %0")

;;; *** and ***

(define_insn "anddi3"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
          (and:DI (match_operand:DI 1 "register_operand" "%r,r")
                  (match_operand:DI 2 "general_operand"   "r,L")))]
    ""
    "@
     and\\t%2, %1, %0
     andi\\t%2, %1, %0")

(define_insn "andsi3"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
          (and:SI (match_operand:SI 1 "register_operand" "%r,r")
                  (match_operand:SI 2 "general_operand"   "r,L")))]
    ""
    "@
     and32\\t%2, %1, %0
     andi32\\t%2, %1, %0")

(define_insn "andhi3"
    [(set (match_operand:HI 0 "register_operand" "=r,r")
          (and:HI (match_operand:HI 1 "register_operand" "%r,r")
                  (match_operand:HI 2 "general_operand"   "r,L")))]
    ""
    "@
     and16\\t%2, %1, %0
     andi16\\t%2, %1, %0")

(define_insn "andqi3"
    [(set (match_operand:QI 0 "register_operand" "=r,r")
          (and:QI (match_operand:QI 1 "register_operand" "%r,r")
                  (match_operand:QI 2 "general_operand"   "r,L")))]
    ""
    "@
     and8\\t%2, %1, %0
     andi8\\t%2, %1, %0")

;;; *** or ***

(define_insn "iordi3"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
          (ior:DI (match_operand:DI 1 "register_operand" "%r,r")
                  (match_operand:DI 2 "general_operand"   "r,L")))]
    ""
    "@
     or\\t%2, %1, %0
     ori\\t%2, %1, %0")   

(define_insn "iorsi3"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
          (ior:SI (match_operand:SI 1 "register_operand" "%r,r")
                  (match_operand:SI 2 "general_operand"   "r,L")))]
    ""
    "@
     or32\\t%2, %1, %0
     ori32\\t%2, %1, %0")

(define_insn "iorhi3"
    [(set (match_operand:HI 0 "register_operand" "=r,r")
          (ior:HI (match_operand:HI 1 "register_operand" "%r,r")
                  (match_operand:HI 2 "general_operand"   "r,L")))]
    ""
    "@
     or16\\t%2, %1, %0
     ori16\\t%2, %1, %0")

(define_insn "iorqi3"
    [(set (match_operand:QI 0 "register_operand" "=r,r")
          (ior:QI (match_operand:QI 1 "register_operand" "%r,r")
                  (match_operand:QI 2 "general_operand"   "r,L")))]
    ""
    "@
     or8\\t%2, %1, %0
     ori8\\t%2, %1, %0")


;;; *** exclusive or ***
    
(define_insn "xordi3"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
          (xor:DI (match_operand:DI 1 "register_operand" "%r,r")
                  (match_operand:DI 2 "general_operand"   "r,L")))]
    ""
    "@
     xor\\t%2, %1, %0
     xori\\t%2, %1, %0")   

(define_insn "xorsi3"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
          (xor:SI (match_operand:SI 1 "register_operand" "%r,r")
                  (match_operand:SI 2 "general_operand"   "r,L")))]
    ""
    "@
     xor32\\t%2, %1, %0
     xori32\\t%2, %1, %0")

(define_insn "xorhi3"
    [(set (match_operand:HI 0 "register_operand" "=r,r")
          (xor:HI (match_operand:HI 1 "register_operand" "%r,r")
                  (match_operand:HI 2 "general_operand"   "r,L")))]
    ""
    "@
     xor16\\t%2, %1, %0
     xori16\\t%2, %1, %0")

(define_insn "xorqi3"
    [(set (match_operand:QI 0 "register_operand" "=r,r")
          (xor:QI (match_operand:QI 1 "register_operand" "%r,r")
                  (match_operand:QI 2 "general_operand"   "r,L")))]
    ""
    "@
     xor8\\t%2, %1, %0
     xori8\\t%2, %1, %0")

;;; *** negation ***

(define_insn "negdi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (neg:DI (match_operand:DI 1 "register_operand" "r")))]
    ""
    "neg\\t%1, %0")

(define_insn "negsi2"
    [(set (match_operand:SI 0 "register_operand" "=r")
          (neg:SI (match_operand:SI 1 "register_operand" "r")))]
    ""
    "neg32\\t%1, %0")

(define_insn "neghi2"
    [(set (match_operand:HI 0 "register_operand" "=r")
          (neg:HI (match_operand:HI 1 "register_operand" "r")))]
    ""
    "neg16\\t%1, %0")

(define_insn "negqi2"
    [(set (match_operand:QI 0 "register_operand" "=r")
          (neg:QI (match_operand:QI 1 "register_operand" "r")))]
    ""
    "neg8\\t%1, %0")

;;; *** not ***

(define_insn "one_cmpldi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (not:DI (match_operand:DI 1 "register_operand" "r")))]
    ""
    "not\\t%1, %0")

(define_insn "one_cmplsi2"
    [(set (match_operand:SI 0 "register_operand" "=r")
          (not:SI (match_operand:SI 1 "register_operand" "r")))]
    ""
    "not32\\t%1, %0")

(define_insn "one_cmplhi2"
    [(set (match_operand:HI 0 "register_operand" "=r")
          (not:HI (match_operand:HI 1 "register_operand" "r")))]
    ""
    "not16\\t%1, %0")

(define_insn "one_cmplqi2"
    [(set (match_operand:QI 0 "register_operand" "=r")
          (not:QI (match_operand:QI 1 "register_operand" "r")))]
    ""
    "not8\\t%1, %0")

;;; *** addition ***

(define_insn "adddf3"
    [(set (match_operand:DF 0 "register_operand" "=r")
          (plus:DF (match_operand:DF 1 "register_operand" "%r")
                   (match_operand:DF 2 "register_operand" "r")))]
    ""
    "fadd\\t%2, %1, %0")

(define_insn "addsf3"
    [(set (match_operand:SF 0 "register_operand" "=r")
          (plus:SF (match_operand:SF 1 "register_operand" "%r")
                   (match_operand:SF 2 "register_operand" "r")))]
    ""
    "fadd32\\t%2, %1, %0")

(define_insn "adddi3"
    [(set (match_operand:DI 0 "register_operand" "=r,r,r,r")
          (plus:DI (match_operand:DI 1 "register_operand" "%r,r,r,r")
                   (match_operand:DI 2 "general_operand"   "r,O,P,L")))]
    ""
    "@
     add\\t%2, %1, %0
     inc\\t%1, %0
     dec\\t%1, %0
     addi\\t%2, %1, %0")

(define_insn "addsi3"
    [(set (match_operand:SI 0 "register_operand" "=r,r,r,r")
          (plus:SI (match_operand:SI 1 "register_operand" "%r,r,r,r")
                   (match_operand:SI 2 "general_operand"   "r,O,P,L")))]
    ""
    "@
     add32\\t%2, %1, %0
     inc32\\t%1, %0
     dec32\\t%1, %0
     addi32\\t%2, %1, %0")

(define_insn "addhi3"
    [(set (match_operand:HI 0 "register_operand" "=r,r,r,r")
          (plus:HI (match_operand:HI 1 "register_operand" "%r,r,r,r")
                   (match_operand:HI 2 "general_operand"   "r,O,P,L")))]
    ""
    "@
     add16\\t%2, %1, %0
     inc16\\t%1, %0
     dec16\\t%1, %0
     addi16\\t%2, %1, %0")

(define_insn "addqi3"
    [(set (match_operand:QI 0 "register_operand" "=r,r,r,r")
          (plus:QI (match_operand:QI 1 "register_operand" "%r,r,r,r")
                   (match_operand:QI 2 "general_operand"   "r,O,P,L")))]
    ""
    "@
     add8\\t%2, %1, %0
     inc8\\t%1, %0
     dec8\\t%1, %0
     addi8\\t%2, %1, %0")

;;; *** subtraction ***

(define_insn "subdf3"
    [(set (match_operand:DF 0 "register_operand" "=r")
          (minus:DF (match_operand:DF 1 "register_operand" "r")
                    (match_operand:DF 2 "register_operand" "r")))]
    ""
    "fsub\\t%2, %1, %0")

(define_insn "subsf3"
    [(set (match_operand:SF 0 "register_operand" "=r")
          (minus:SF (match_operand:SF 1 "register_operand" "r")
                    (match_operand:SF 2 "register_operand" "r")))]
    ""
    "fsub32\\t%2, %1, %0")

(define_insn "subdi3"
    [(set (match_operand:DI 0 "register_operand" "=r,r,r,r")
          (minus:DI (match_operand:DI 1 "register_operand" "r,r,r,r")
                    (match_operand:DI 2 "general_operand"  "r,O,P,L")))]
    ""
    "@
     sub\\t%2, %1, %0
     dec\\t%1, %0
     inc\\t%1, %0
     subi\\t%2, %1, %0")

(define_insn "subsi3"
    [(set (match_operand:SI 0 "register_operand" "=r,r,r,r")
          (minus:SI (match_operand:SI 1 "register_operand" "r,r,r,r")
                    (match_operand:SI 2 "general_operand"  "r,O,P,L")))]
    ""
    "@
     sub32\\t%2, %1, %0
     dec32\\t%1, %0
     inc32\\t%1, %0
     subi32\\t%2, %1, %0")

(define_insn "subhi3"
    [(set (match_operand:HI 0 "register_operand" "=r,r,r,r")
          (minus:HI (match_operand:HI 1 "register_operand" "r,r,r,r")
                    (match_operand:HI 2 "general_operand"  "r,O,P,L")))]
    ""
    "@
     sub16\\t%2, %1, %0
     dec16\\t%1, %0
     inc16\\t%1, %0
     subi16\\t%2, %1, %0")

(define_insn "subqi3"
    [(set (match_operand:QI 0 "register_operand" "=r,r,r,r")
          (minus:QI (match_operand:QI 1 "register_operand" "r,r,r,r")
                    (match_operand:QI 2 "general_operand"  "r,O,P,L")))]
    ""
    "@
     sub8\\t%2, %1, %0
     dec8\\t%1, %0
     inc8\\t%1, %0
     subi8\\t%2, %1, %0")

;;; *** multiplication ***

(define_insn "muldf3"
    [(set (match_operand:DF 0 "register_operand" "=r")
          (mult:DF (match_operand:DF 1 "register_operand" "%r")
                   (match_operand:DF 2 "register_operand" "r")))]
    ""
    "fmul\\t%2, %1, %0")

(define_insn "multsf3"
    [(set (match_operand:SF 0 "register_operand" "=r")
          (mult:SF (match_operand:SF 1 "register_operand" "%r")
                   (match_operand:SF 2 "register_operand" "r")))]
    ""
    "fmul32\\t%2, %1, %0")

(define_insn "muldi3"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
          (mult:DI (match_operand:DI 1 "register_operand" "%r,r")
                   (match_operand:DI 2 "general_operand"   "r,K")))]
    ""
    "@
     mul\\t%2, %1, %0
     muli\\t%2, %1, %0")

(define_insn "mulsi3"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
          (mult:SI (match_operand:SI 1 "register_operand" "%r,r")
                   (match_operand:SI 2 "general_operand"   "r,K")))]
    ""
    "@
     mul32\\t%2, %1, %0
     muli32\\t%2, %1, %0")

(define_insn "mulhi3"
    [(set (match_operand:HI 0 "register_operand" "=r,r")
          (mult:HI (match_operand:HI 1 "register_operand" "%r,r")
                   (match_operand:HI 2 "general_operand"   "r,K")))]
    ""
    "@
     mul16\\t%2, %1, %0
     muli16\\t%2, %1, %0")

(define_insn "mulqi3"
    [(set (match_operand:QI 0 "register_operand" "=r,r")
          (mult:QI (match_operand:QI 1 "register_operand" "%r,r")
                   (match_operand:QI 2 "general_operand"   "r,K")))]
    ""
    "@
     mul8\\t%2, %1, %0
     muli8\\t%2, %1, %0")

;;; *** division ***

(define_insn "divdf3"
    [(set (match_operand:DF 0 "register_operand" "=r")
          (div:DF (match_operand:DF 1 "register_operand" "%r")
                  (match_operand:DF 2 "register_operand" "r")))]
    ""
    "fdiv\\t%2, %1, %0")

(define_insn "divsf3"
    [(set (match_operand:SF 0 "register_operand" "=r")
          (div:SF (match_operand:SF 1 "register_operand" "%r")
                  (match_operand:SF 2 "register_operand" "r")))]
    ""
    "fdiv32\\t%2, %1, %0")

(define_insn "divdi3"
    [(set (match_operand:DI 0 "register_operand" "=r,r")
          (div:DI (match_operand:DI 1 "register_operand" "r,r")
                  (match_operand:DI 2 "general_operand"  "r,K")))]
    ""
    "@
     div.s\\t%2, %1, %0
     divi.s\\t%2, %1, %0")

(define_insn "divsi3"
    [(set (match_operand:SI 0 "register_operand" "=r,r")
          (div:SI (match_operand:SI 1 "register_operand" "r,r")
                  (match_operand:SI 2 "general_operand"  "r,K")))]
    ""
    "@
     div32.s\\t%2, %1, %0
     divi32.s\\t%2, %1, %0")

(define_insn "divhi3"
    [(set (match_operand:HI 0 "register_operand" "=r,r")
          (div:HI (match_operand:HI 1 "register_operand" "r,r")
                  (match_operand:HI 2 "general_operand"  "r,K")))]
    ""
    "@
     div16.s\\t%2, %1, %0
     divi16.s\\t%2, %1, %0")

(define_insn "divqi3"
    [(set (match_operand:QI 0 "register_operand" "=r,r")
          (div:QI (match_operand:QI 1 "register_operand" "r,r")
                  (match_operand:QI 2 "general_operand"  "r,K")))]
    ""
    "@
     div8.s\\t%2, %1, %0
     divi8.s\\t%2, %1, %0")

;;; *** unsigned division ***

(define_insn "udivdi3"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (udiv:DI (match_operand:DI 1 "register_operand" "r")
                   (match_operand:DI 2 "register_operand" "r")))]
    ""
    "div\\t%2, %1, %0")

(define_insn "udivsi3"
    [(set (match_operand:SI 0 "register_operand" "=r")
          (udiv:SI (match_operand:SI 1 "register_operand" "r")
                   (match_operand:SI 2 "register_operand" "r")))]
    ""
    "div32\\t%2, %1, %0")

(define_insn "udivhi3"
    [(set (match_operand:HI 0 "register_operand" "=r")
          (udiv:HI (match_operand:HI 1 "register_operand" "r")
                   (match_operand:HI 2 "register_operand" "r")))]
    ""
    "div16\\t%2, %1, %0")

(define_insn "udivqi3"
    [(set (match_operand:QI 0 "register_operand" "=r")
          (udiv:QI (match_operand:QI 1 "register_operand" "r")
                   (match_operand:QI 2 "register_operand" "r")))]
    ""
    "div8\\t%2, %1, %0")

;;; *** sign extension ***

(define_insn "extendsidi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (sign_extend:DI (match_operand:SI 1 "register_operand" "r")))]
    ""
    "move32.s\\tr0, %1, %0")

(define_insn "extendhidi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (sign_extend:DI (match_operand:HI 1 "register_operand" "r")))]
    ""
    "move16.s\\tr0, %1, %0")

(define_insn "extendqidi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (sign_extend:DI (match_operand:QI 1 "register_operand" "r")))]
    ""
    "move8.s\\tr0, %1, %0")

;;; *** zero extension ***

(define_expand "zero_extendsidi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (zero_extend:DI (match_operand:SI 1 "register_operand" "r")))]
    ""
    "{ 
        fcpu_zero_extend_emit (operands [0], operands [1]);

        DONE;
     }")

(define_insn ""
    [(set (match_operand:DI 0 "register_operand" "=r")
          (zero_extend:DI (subreg:SI (match_dup 0) 0)))]
    ""
    "loadconsx.2\\t0, %0")

(define_expand "zero_extendhidi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (zero_extend:DI (match_operand:HI 1 "register_operand" "r")))]
    ""
    "{
        fcpu_zero_extend_emit (operands [0], operands [1]);
        
        DONE;
     }")

(define_insn ""
    [(set (match_operand:DI 0 "register_operand" "=r")
          (zero_extend:DI (subreg:HI (match_dup 0) 0)))]
    ""
    "loadconsx.1\\t0, %0")

(define_insn "zero_extendqidi2"
    [(set (match_operand:DI 0 "register_operand" "=r")
          (zero_extend:DI (match_operand:QI 1 "register_operand" "r")))]
    ""
    "andi\\t255, %1, %0")
                      
;;; *** calling ***

(define_expand "call"
   [(parallel [(call (match_operand:DI 0 "memory_operand" "m")
                     (match_operand 1 "immediate_operand" "i"))
               (clobber (reg:DI 60))] )]
   ""
   "{
       if (GET_CODE (operands [0]) == MEM &&
           GET_CODE (XEXP (operands [0], 0)) != REG)
         XEXP (operands [0], 0) = force_reg (Pmode, XEXP (operands [0], 0)); 
    }")
               
(define_insn ""
   [(parallel [(call (match_operand:DI 0 "memory_operand" "m")
                     (match_operand    1 "immediate_operand" "i"))
               (clobber (reg:DI 60))] )]
   ""
   "jmpa\\tr0, %0, r60")

(define_expand "call_value"
   [(parallel [(set (match_operand 0 "register_operand" "=r")
                    (call (match_operand:DI 1 "memory_operand" "m")
                          (match_operand    2 "immediate_operand" "i")))
               (clobber (reg:DI 60))] )]
   ""
   "{
       if (GET_CODE (operands [1]) == MEM &&
           GET_CODE (XEXP (operands [1], 0)) != REG)
         XEXP (operands [1], 0) = force_reg (Pmode, XEXP (operands [1], 0));
    }")

(define_insn ""
   [(parallel [(set (match_operand 0 "register_operand" "=r")
                    (call (match_operand:DI 1 "memory_operand" "m")
	                      (match_operand    2 "immediate_operand" "i")))
               (clobber (reg:DI 60))] )]
   ""
   "jmpa\\tr0, %1, r60")

;;; *** comparison ***

(define_expand "cmpdi"
  [(set (cc0)
        (compare:DI (match_operand:DI 0 "register_operand" "r,r")
                    (match_operand:DI 1 "general_operand" "r,L")))]
  ""
  "{ 
     fcpu_compare_operands (operands); 
     
     DONE;
   }")

(define_expand "cmpsi"
  [(set (cc0)
        (compare:SI (match_operand:SI 0 "register_operand" "r,r")
                    (match_operand:SI 1 "general_operand" "r,L")))]
  ""
  "{ 
     fcpu_compare_operands (operands); 
     
     DONE;
   }")

(define_expand "cmphi"
  [(set (cc0)
        (compare:HI (match_operand:HI 0 "register_operand" "r,r")
                    (match_operand:HI 1 "general_operand" "r,L")))]
  ""
  "{ 
     fcpu_compare_operands (operands); 
     
     DONE;
   }")

(define_expand "cmpqi"
  [(set (cc0)
        (compare:QI (match_operand:QI 0 "register_operand" "r,r")
                    (match_operand:QI 1 "general_operand" "r,L")))]
  ""
  "{ 
     fcpu_compare_operands (operands); 
     
     DONE;
   }")

(define_expand "cmpdf"
  [(set (cc0)
        (compare:DF (match_operand:DF 0 "register_operand" "r")
                    (match_operand:DF 1 "register_operand" "r")))]
  ""
  "{ 
     fcpu_compare_operands (operands); 
     
     DONE;
   }")

(define_expand "cmpsf"
  [(set (cc0)
        (compare:SF (match_operand:SF 0 "register_operand" "r")
                    (match_operand:SF 1 "register_operand" "r")))]
  ""
  "{ 
     fcpu_compare_operands (operands); 
     
     DONE;
   }")

;;; *** conditional moving ***

(define_expand "movdicc"
  [(set (match_operand:DI 0 "register_operand" "=r")
        (if_then_else (match_operand 1 "comparison_operator" "")
                      (match_operand:DI 2 "register_operand" "r")
                      (match_operand:DI 3 "register_operand" "r")))]
  ""
  "{ operands [1] = fcpu_compare_move_emit (GET_CODE (operands [1])); }")

(define_expand "movsicc"
  [(set (match_operand:SI 0 "register_operand" "=r")
        (if_then_else (match_operand 1 "comparison_operator" "")
                      (match_operand:SI 2 "register_operand" "r")
                      (match_operand:SI 3 "register_operand" "r")))]
  ""
  "{ operands [1] = fcpu_compare_move_emit (GET_CODE (operands [1])); }")

(define_expand "movhicc"
  [(set (match_operand:HI 0 "register_operand" "=r")
        (if_then_else (match_operand 1 "comparison_operator" "")
                      (match_operand:HI 2 "register_operand" "r")
                      (match_operand:HI 3 "register_operand" "r")))]
  ""
  "{ operands [1] = fcpu_compare_move_emit (GET_CODE (operands [1])); }")

(define_expand "movqicc"
  [(set (match_operand:QI 0 "register_operand" "=r")
        (if_then_else (match_operand 1 "comparison_operator" "")
                      (match_operand:QI 2 "register_operand" "r")
                      (match_operand:QI 3 "register_operand" "r")))]
  ""
  "{ operands [1] = fcpu_compare_move_emit (GET_CODE (operands [1])); }")

(define_expand "movdfcc"
  [(set (match_operand:DF 0 "register_operand" "=r")
        (if_then_else (match_operand 1 "comparison_operator" "")
                      (match_operand:DF 2 "register_operand" "r")
                      (match_operand:DF 3 "register_operand" "r")))]
  ""
  "{ operands [1] = fcpu_compare_move_emit (GET_CODE (operands [1])); }")

(define_expand "movsfcc"
  [(set (match_operand:DI 0 "register_operand" "=r")
        (if_then_else (match_operand 1 "comparison_operator" "")
                      (match_operand:SF 2 "register_operand" "r")
                      (match_operand:SF 3 "register_operand" "r")))]
  ""
  "{ operands [1] = fcpu_compare_move_emit (GET_CODE (operands [1])); }")

(define_insn ""
  [(set (match_operand 0 "register_operand" "=r")
        (if_then_else (match_operator:DI 1 "comparison_operator"
                                         [(match_operand:DI 2 "register_operand" "r")
                                          (const_int 0)] )
                      (match_operand 3 "register_operand" "r")
                      (match_operand 4 "register_operand" "0")))]
  "GET_CODE (operands [1]) == EQ || GET_CODE (operands [1]) == NE"
  "* return fcpu_compare_move_output (GET_CODE (operands [1]), operands [2], operands [0], operands [3]);")

;;; *** maximum ***

(define_insn "umaxdi3"
  [(set (match_operand:DI 0 "register_operand" "=r,r")
        (umax:DI (match_operand:DI 1 "register_operand" "%r,r")
                 (match_operand:DI 2 "general_operand" "r,L")))]
  ""
  "@
   max\\t%2, %1, %0
   maxi\\t%2, %1, %0")

(define_insn "umaxsi3"
  [(set (match_operand:SI 0 "register_operand" "=r,r")
        (umax:SI (match_operand:SI 1 "register_operand" "%r,r")
                 (match_operand:SI 2 "general_operand" "r,L")))]
  ""
  "@
   max32\\t%2, %1, %0
   maxi32\\t%2, %1, %0")

(define_insn "umaxhi3"
  [(set (match_operand:HI 0 "register_operand" "=r,r")
        (umax:HI (match_operand:HI 1 "register_operand" "%r,r")
                 (match_operand:HI 2 "general_operand" "r,L")))]
  ""
  "@
   max16\\t%2, %1, %0
   maxi16\\t%2, %1, %0")

(define_insn "umaxqi3"
  [(set (match_operand:QI 0 "register_operand" "=r,r")
        (umax:QI (match_operand:QI 1 "register_operand" "%r,r")
                 (match_operand:QI 2 "general_operand" "r,L")))]
  ""
  "@
   max8\\t%2, %1, %0
   maxi8\\t%2, %1, %0")

;;; *** minimum ***

(define_insn "umindi3"
  [(set (match_operand:DI 0 "register_operand" "=r,r")
        (umin:DI (match_operand:DI 1 "register_operand" "%r,r")
                 (match_operand:DI 2 "general_operand" "r,L")))]
  ""
  "@
   min\\t%2, %1, %0
   mini\\t%2, %1, %0")

(define_insn "uminsi3"
  [(set (match_operand:SI 0 "register_operand" "=r,r")
        (umin:SI (match_operand:SI 1 "register_operand" "%r,r")
                 (match_operand:SI 2 "general_operand" "r,L")))]
  ""
  "@
   min32\\t%2, %1, %0
   mini32\\t%2, %1, %0")

(define_insn "uminhi3"
  [(set (match_operand:HI 0 "register_operand" "=r,r")
        (umin:HI (match_operand:HI 1 "register_operand" "%r,r")
                 (match_operand:HI 2 "general_operand" "r,L")))]
  ""
  "@
   min16\\t%2, %1, %0
   mini16\\t%2, %1, %0")

(define_insn "uminqi3"
  [(set (match_operand:QI 0 "register_operand" "=r,r")
        (umin:QI (match_operand:QI 1 "register_operand" "%r,r")
                 (match_operand:QI 2 "general_operand" "r,L")))]
  ""
  "@
   min8\\t%2, %1, %0
   mini8\\t%2, %1, %0")

;;; *** absolute value ***

(define_insn "absdi2"
  [(set (match_operand:DI 0 "register_operand" "=r")
        (abs:DI (match_operand:DI 1 "register_operand" "r")))]
  ""
  "abs\\t%1, %0")

(define_insn "abssi2"
  [(set (match_operand:SI 0 "register_operand" "=r")
        (abs:SI (match_operand:SI 1 "register_operand" "r")))]
  ""
  "abs32\\t%1, %0")

(define_insn "abshi2"
  [(set (match_operand:HI 0 "register_operand" "=r")
        (abs:HI (match_operand:HI 1 "register_operand" "r")))]
  ""
  "abs16\\t%1, %0")

(define_insn "absqi2"
  [(set (match_operand:QI 0 "register_operand" "=r")
        (abs:QI (match_operand:QI 1 "register_operand" "r")))]
  ""
  "abs8\\t%1, %0")

;;; *** conditional branching ***

(define_expand "beq"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (EQ); 
   }")

(define_expand "bne"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (NE); 
   }")

(define_expand "blt"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (LT); 
   }")

(define_expand "ble"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (LE); 
   }")

(define_expand "bgt"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (GT); 
   }")

(define_expand "bge"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (GE); 
   }")

(define_expand "bltu"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (LTU); 
   }")

(define_expand "bleu"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (LEU); 
   }")
   
(define_expand "bgtu"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (GTU); 
   }")


(define_expand "bgeu"
  [(parallel [(set (pc)
                   (if_then_else (match_dup 1)
                                 (label_ref (match_operand 0 "" ""))
                                 (pc)))
              (use (match_dup 2))] )]
  ""
  "{ 
     operands [2] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0]));
     operands [1] = fcpu_compare_jump_emit (GEU); 
   }")

(define_insn ""
  [(parallel [(set (pc)
                   (if_then_else (ne:DI (match_operand:DI 0 "register_operand" "r")
                                        (const_int 0))
                                 (label_ref (match_operand:DI 1 "" ""))
                                 (pc)))
              (use (match_operand:DI 2 "register_operand" "r"))] )]
  ""
  "jmpa.n\\t%0, %2 = %1, r0")

(define_insn ""
  [(parallel [(set (pc)
                   (if_then_else (eq:DI (match_operand:DI 0 "register_operand" "r")
                                        (const_int 0))
                                 (label_ref (match_operand:DI 1 "" ""))
                                 (pc)))
              (use (match_operand:DI 2 "register_operand" "r"))] )]
  ""
  "jmpa\\t%0, %2 = %1, r0")

(define_insn ""
  [(parallel [(set (pc)
                   (if_then_else (ne:DI (lshiftrt:DI (match_operand:DI 0 "register_operand" "r")
                                                     (const_int 63))
                                        (const_int 0))
                                 (label_ref (match_operand:DI 1 "" ""))
                                 (pc)))
              (use (match_operand:DI 2 "register_operand" "r"))] )]
  ""
  "jmpa.m\\t%0, %2 = %1, r0")

(define_insn ""
  [(parallel [(set (pc)
                   (if_then_else (eq:DI (lshiftrt:DI (match_operand:DI 0 "register_operand" "r")
                                                     (const_int 63))
                                        (const_int 0))
                                 (label_ref (match_operand:DI 1 "" ""))
                                 (pc)))
              (use (match_operand:DI 2 "register_operand" "r"))] )]
  ""
  "jmpa.mn\\t%0, %2 = %1, r0")

;;; *** jumping ***

(define_insn ""
   [(parallel [(set (pc)
                    (label_ref (match_operand 0 "" "")))
               (use (match_operand 1 "register_operand" "r"))] )]
   ""
   "jmpa\\tr0, %1 = %l0, r0")

(define_expand "jump"
   [(parallel [(set (pc) 
                    (label_ref (match_operand 0 "" "")))
                    (use (match_dup 1))] )]
   ""
   "{ operands [1] = force_reg (Pmode, gen_rtx_LABEL_REF (VOIDmode, operands [0])); }")

(define_insn "indirect_jump"
   [(set (pc)
         (match_operand:DI 0 "register_operand" "r"))]
   ""
   "jmpa\\tr0, %0, r0")

;;; *** conditional setting ***

(define_expand "seq"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (EQ, operands [0]); }")

(define_expand "sne"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (NE, operands [0]); }")

(define_expand "slt"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (LT, operands [0]); }")

(define_expand "sle"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (LE, operands [0]); }")

(define_expand "sgt"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (GT, operands [0]); }")

(define_expand "sge"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (GE, operands [0]); }")

(define_expand "sltu"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (LTU, operands [0]); }")

(define_expand "sleu"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (LEU, operands [0]); }")

(define_expand "sgtu"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (GTU, operands [0]); }")

(define_expand "sgeu"
   [(set (match_operand 0 "register_operand" "=r")
         (match_dup 1))]
   ""
   "{ operands [1] = fcpu_compare_set_emit (GEU, operands [0]); }")

(define_insn ""
  [(set (match_operand:DI 0 "register_operand" "=r,r,r")
        (match_operator:DI 1 "fcpu_comparison_operator"
                        [(match_operand:DI 2 "register_operand" "r,r,N")
                         (match_operand:DI 3 "general_operand" "r,L,r")] ))]
  ""
  "* {
        return fcpu_compare_set_output (GET_CODE (operands [1]), 
                                        operands [0],
                                        operands [2],
                                        operands [3]);
     }")

(define_insn ""
  [(set (match_operand:SI 0 "register_operand" "=r,r,r")
        (match_operator:SI 1 "fcpu_comparison_operator"
                        [(match_operand:SI 2 "register_operand" "r,r,N")
                         (match_operand:SI 3 "general_operand" "r,L,r")] ))]
  ""
  "* {
        return fcpu_compare_set_output (GET_CODE (operands [1]), 
                                        operands [0],
                                        operands [2],
                                        operands [3]);
     }")

(define_insn ""
  [(set (match_operand:HI 0 "register_operand" "=r,r,r")
        (match_operator:HI 1 "fcpu_comparison_operator"
                        [(match_operand:HI 2 "register_operand" "r,r,N")
                         (match_operand:HI 3 "general_operand" "r,L,r")] ))]
  ""
  "* {
        return fcpu_compare_set_output (GET_CODE (operands [1]), 
                                        operands [0],
                                        operands [2],
                                        operands [3]);
     }")

(define_insn ""
  [(set (match_operand:QI 0 "register_operand" "=r,r,r")
        (match_operator:QI 1 "fcpu_comparison_operator"
                        [(match_operand:QI 2 "register_operand" "r,r,N")
                         (match_operand:QI 3 "general_operand" "r,L,r")] ))]
  ""
  "* {
        return fcpu_compare_set_output (GET_CODE (operands [1]), 
                                        operands [0],
                                        operands [2],
                                        operands [3]);
     }")
                                     
;;; *** miscellaneous ***

(define_insn "nop"
    [(const_int 0)]
    ""
    "nop")

